﻿using System;
using System.Linq;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;

namespace SPQR {
	public class OptimizePhysicsRate : Optimize{
        float target = 1f / 45f;
        public OptimizePhysicsRate(OldVam x) : base(x)
        {
            checkDuration = 2.95f;
        }

        public override bool CheckChange()
        {
            if (Time.fixedDeltaTime != target) return true;
            return false;
        }

        public override void DoOptimize()
        {
            Time.fixedDeltaTime = target;
            Log("Optimized physics rate");
        }


    }
}