﻿using System;
using System.Linq;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;

namespace SPQR {
	public class OptimizeSettingSoftphysics : Optimize{
        public OptimizeSettingSoftphysics(OldVam x) : base(x)
        {
            checkDuration = 3.77f;
        }

        public override bool CheckChange()
        {
            if (UserPreferences.singleton.softPhysics) return true;
            return false;
        }

        public override void DoOptimize()
        {
            UserPreferences.singleton.softPhysics = false;
            Log("Optimized vam setting soft physics");
        }


    }
}