﻿using System;
using System.Globalization;
using UnityEngine;
using UnityEngine.XR;
using System.Text;
using System.Linq;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using UnityEngine.XR;
using MacGruber;
using MVR.FileManagementSecure;
using Random = System.Random;
using Random2 = UnityEngine.Random;

/*

- performance fixed, collision tracking used to stack up in scenes and never cleared out
- 

*/

namespace SPQR
{
    public class XXTriggers : MVRScript
    {
		

        private bool gameIsVR;

        GameObject playerHands;
        float collisionThreshold = 0.05f;
		float collisionCooldown = 1f;
		float expireDefault = 1f;

        Color colorGrey = new Color(0.8f, 0.8f, 0.8f);
        Color colorGreen = new Color(0.3f, 0.8f, 0.3f);
        Color colorBlue = new Color(0.3f, 0.3f, 0.8f);

        string SavePath = "Saves/PluginData/XXTriggers/";
        string SaveExtension = "json";

        float[] myClock = new float[21];
        float[] expireTime = new float[21];

		int titles = 0;
        protected JSONStorableString myString;


        int currentTab = 1;
        int totalTabs = 20;

        List<string> bodypartsList = new List<string>() { "head", "tongue", "chest",  "glutes", "hand","nipple", "pelvis",  "thigh", "foot", "leg", "upper body",  "arm", "shoulder", "breast",  "jaw", "neck", "hip", "penis","vagina","lips" };

        List<object> menuElements = new List<object>() { };
        UIDynamicButton btnOnCollision, btnOnExpire;

        JSONStorableString[] variableThisName = new JSONStorableString[21];
        JSONStorableBool[][] variableIsTrigger = new JSONStorableBool[21][];
        JSONStorableFloat[] thresholdMin = new JSONStorableFloat[21];
        JSONStorableFloat[] thresholdMax = new JSONStorableFloat[21];
        JSONStorableFloat[] thresholdCooldown = new JSONStorableFloat[21];
        JSONStorableFloat[] thresholdExpired = new JSONStorableFloat[21];


        private EventTrigger[] myEventTriggerUpdate = new EventTrigger[21];
        private EventTrigger[] myEventTriggerExpire = new EventTrigger[21];
        Dictionary<string, UIDynamicToggle> currentToggles = new Dictionary<string, UIDynamicToggle>() { };

        JSONStorableStringChooser presetSelector;

		Dictionary<string, UIDynamicButton> buttons = new Dictionary<string, UIDynamicButton>();

		public void updateVariables(){
			
			
		}

        public override void Init()
        {
            Utils.OnInitUI(CreateUIElement);
            gameIsVR = XRSettings.isDeviceActive && !string.IsNullOrEmpty(XRSettings.loadedDeviceName);


            if (containingAtom.type != "Person")
            {
                SuperController.LogError("This plugin must be added to a Person atom!");
                return;
            }


            List<string> choicesPreset = new List<string>() {};
            for (var i = 1; i <= totalTabs; i++) choicesPreset.Add(i.ToString());

            CreateTitle("XXTriggers", 35, false);

            presetSelector = new JSONStorableStringChooser("Group", choicesPreset, currentTab.ToString(), "Group", OnPresetChange);
            RegisterStringChooser(presetSelector);
            UIDynamicPopup udp = CreateScrollablePopup(presetSelector, true);
            udp.labelWidth = 300f;


            


             buttons.Add("save_preset", CreateButton("Save Preset", false));
            buttons["save_preset"].button.onClick.AddListener(() =>
            {
                if (!FileManagerSecure.DirectoryExists(SavePath))
                {
                    FileManagerSecure.CreateDirectory(SavePath);
                }
                var fileBrowserUI = SuperController.singleton.fileBrowserUI;
                var folder = SavePath;
                folder = SPQRUtils.RemoveTrailingSlash(folder);

                fileBrowserUI.GotoDirectory(@"/");
                fileBrowserUI.SetTitle("Save preset");
                fileBrowserUI.fileRemovePrefix = null;
                fileBrowserUI.hideExtension = true;
                fileBrowserUI.keepOpen = false;
                fileBrowserUI.canCancel = true;
                fileBrowserUI.fileFormat = SaveExtension;
                fileBrowserUI.defaultPath = folder;
                fileBrowserUI.showDirs = true;
                fileBrowserUI.showFiles = true;
                fileBrowserUI.shortCuts = null;
                fileBrowserUI.browseVarFilesAsDirectories = false;
                fileBrowserUI.SetTextEntry(true);
                fileBrowserUI.Show(HandleSavePreset);
                fileBrowserUI.fileEntryField.text = (int)(DateTime.UtcNow - new DateTime(1970, 1, 1)).TotalSeconds + "." + SaveExtension;
                fileBrowserUI.ActivateFileNameField();
            });



            buttons.Add("load_preset", CreateButton("Load Preset", true));
            buttons["load_preset"].button.onClick.AddListener(() =>
            {
                var folder = SavePath;
                folder = SPQRUtils.RemoveTrailingSlash(folder);
                //var shortcuts = FileManagerSecure.GetShortCutsForDirectory(SavePath);
                SuperController.singleton.GetMediaPathDialog(HandleLoadPreset, SaveExtension, folder, false, true, false, null, false);
            });



            Utils.SetupSpacer(this, 40, false);
            Utils.SetupSpacer(this, 40, true);

           
            for (var i = 1; i <= totalTabs; i++)
            {
                myClock[i] = -1f;
                expireTime[i] = -1f;

                variableThisName[i] = new JSONStorableString("Name "+i, "", UpdateVarValue);
                variableThisName[i].storeType = JSONStorableParam.StoreType.Full;
                RegisterString(variableThisName[i]);

                variableIsTrigger[i] = new JSONStorableBool[bodypartsList.Count];
                for (var j = 0; j < bodypartsList.Count; j++) {
                    variableIsTrigger[i][j] = new JSONStorableBool("Trigger "+i+" - "+bodypartsList[j], false);
                    variableIsTrigger[i][j].storeType = JSONStorableParam.StoreType.Full;
                    RegisterBool(variableIsTrigger[i][j]);
                }


                thresholdMin[i] = new JSONStorableFloat("Min Impact " + i+" (force)", 0.05f, BlendCallback, 0f, 10f, true);
                thresholdMin[i].storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(thresholdMin[i]);


                thresholdMax[i] = new JSONStorableFloat("Max Impact " + i +" (force)", 10f, BlendCallback, 0f, 10f, true);
                thresholdMax[i].storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(thresholdMax[i]);
                

                thresholdCooldown[i] = new JSONStorableFloat("Cooldown " + i+" (sec)", collisionCooldown, BlendCallback, 0f, 60f, true);
                thresholdCooldown[i].storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(thresholdCooldown[i]);
                

                thresholdExpired[i] = new JSONStorableFloat("Expire trigger " + i +" (sec)", expireDefault, BlendCallback, 0f, 60f, true);
                thresholdExpired[i].storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(thresholdExpired[i]);


                myEventTriggerUpdate[i] = new EventTrigger(this, "TriggerOnUpdate "+i);
                myEventTriggerExpire[i] = new EventTrigger(this, "TriggerOnExpire "+i);
                
               
            }


            SimpleTriggerHandler.LoadAssets_p67();
            ChangeTab(currentTab);
            UIUpdate();
        }



        void ChangeTab(string s)
        {
            ChangeTab(int.Parse(s));
        }

        
        void ChangeTab(int s)
        {
            currentTab = s;

            if (presetSelector.val != s.ToString()) presetSelector.val = s.ToString();

            Utils.RemoveUIElements(this, menuElements);
            menuElements = new List<object>() { };

            for (var i = 1; i <= totalTabs; i++)
            {
                if(currentTab == i)
                {
                    menuElements.Add(Utils.SetupTextInput(this, "Name " + currentTab, variableThisName[i], false));

                    for (var j = 0; j < bodypartsList.Count; j++)
                    {
                        currentToggles[bodypartsList[j]] = CreateToggle(variableIsTrigger[i][j], false);
                        menuElements.Add(currentToggles[bodypartsList[j]]); ;
                    }

                    menuElements.Add(CreateSlider(thresholdMin[i], true));
                    menuElements.Add(CreateSlider(thresholdMax[i], true));
                    menuElements.Add(CreateSlider(thresholdCooldown[i], true));
                    var sliderExpired = CreateSlider(thresholdExpired[i],true);
                    menuElements.Add(sliderExpired) ;

                    btnOnCollision = Utils.SetupButton(this, "Trigger On Collision", myEventTriggerUpdate[i].OpenPanel, true);
                    btnOnExpire = Utils.SetupButton(this, "Trigger On Expire", myEventTriggerExpire[i].OpenPanel, true);

                    btnOnCollision.buttonColor = colorGrey;
                    btnOnExpire.buttonColor = colorGrey;

                    menuElements.Add(btnOnCollision);
                    menuElements.Add(btnOnExpire);
                    menuElements.Add(Utils.SetupButton(this, "Test Collision Trigger", TestTrigger, true));
                    menuElements.Add(Utils.SetupButton(this, "Test Expire Trigger", TestExpireTrigger, true));
                }
            }

        }

        private void UIUpdate()
        {
        }
	

        void Start()
        {	
			RefreshColliders();
        }

        void Update()
        {
           
            for (var i = 1; i <= totalTabs; i++)
            {
                myEventTriggerUpdate[i].Update();
                myEventTriggerExpire[i].Update();

                if (expireTime[i] > -1 && expireTime[i] < Time.time)
                {
                    TriggerExpired(i);
                }
                if (myClock[i] > 0.0f) myClock[i] -= Time.deltaTime;

            }

			
        }

        void FixedUpdate()
        {
           
        }
		
		void OnEnable(){
			RefreshColliders();
		}

        void OnDisable()
        {
            containingAtom.GetComponentsInChildren<Rigidbody>().ToList().ForEach(f =>
			{
				try{
				 f.gameObject.GetComponent<TriggerCollide>().OnCollide -= ObserveTrigger;
				} catch(Exception e){
					
				}
			});
        }
		void OnReload()
        {
            OnDisable();
        }
	   
		
        void OnPresetChange(string s)
        {
            ChangeTab(s);
        }

        public override JSONClass GetJSON(bool includePhysical = true, bool includeAppearance = true, bool forceStore = false)
		{
			JSONClass jc = base.GetJSON(includePhysical, includeAppearance, forceStore);
			if (includePhysical || forceStore)
			{
				needsStore = true;
                for (var i = 1; i <= totalTabs; i++)
                {
                    jc[myEventTriggerUpdate[i].Name] = myEventTriggerUpdate[i].GetJSON(base.subScenePrefix);
                    jc[myEventTriggerExpire[i].Name] = myEventTriggerExpire[i].GetJSON(base.subScenePrefix);
                }
			}
			return jc;
		}
		
		public override void LateRestoreFromJSON(JSONClass jc, bool restorePhysical = true, bool restoreAppearance = true, bool setMissingToDefault = true)
		{
			base.LateRestoreFromJSON(jc, restorePhysical, restoreAppearance, setMissingToDefault);
			if (!base.physicalLocked && restorePhysical && !IsCustomPhysicalParamLocked("trigger"))
			{
                for (var i = 1; i <= totalTabs; i++)
                {
                    myEventTriggerUpdate[i].RestoreFromJSON(jc, base.subScenePrefix, base.mergeRestore, setMissingToDefault);
                    myEventTriggerExpire[i].RestoreFromJSON(jc, base.subScenePrefix, base.mergeRestore, setMissingToDefault);
                }
			}
		}

        void OnDestroy()
        {
            Utils.OnDestroyUI();
            OnDisable();
            for (var i = 1; i <= totalTabs; i++)
            {
                myEventTriggerUpdate[i].Remove();
                myEventTriggerExpire[i].Remove();
            }
        }

	
		public void UpdateVarValue(string s){

		}	
		void BlendCallback(JSONStorableFloat jf){
		}
		
	    private void TestTrigger()
        {

           Trigger(currentTab);

        }
        private void TestExpireTrigger()
        {
            TriggerExpired(currentTab);

        }
        private void Trigger(int i)
        {
            myEventTriggerUpdate[i].Trigger();
            expireTime[i] = Time.time + thresholdExpired[i].val;

            if (i == currentTab)
            {
                btnOnCollision.buttonColor = colorGreen;
                StartCoroutine(CoroutineFlashTrigger(i));
            }

        }
        private void TriggerExpired(int i)
        {
            expireTime[i] = -1f;
            myEventTriggerExpire[i].Trigger();

            //collisionsPreview.val = "PREVIEW: EXPIRED";
            //dtext4.backgroundColor = new Color(0.33f, 0.33f, 1f, 0.7f);
            if (i == currentTab) {
                btnOnExpire.buttonColor = colorBlue;
                StartCoroutine(CoroutineFlashExpiredTrigger(i));
            }

        }

        void DeleteColliders_p67()
        {
            var items = containingAtom.GetComponentsInChildren<Rigidbody>().ToList();
            if (items.Count < 1) return;
            items.ForEach(f =>
            {
                try
                {
                    if (f.gameObject == null) return;
                    Component[] comps = f.gameObject.GetComponents<Component>();
                    if (comps.Length < 1) return;
                    foreach (var c in comps)
                    {
                        if (c.GetType().FullName.Contains("TriggerCollide"))
                        {
                            UnityEngine.Object.Destroy(c);
                        }


                    }
                }
                catch (Exception e)
                {
                    SuperController.LogMessage("deletecolliders: " + e);
                }
            });
        }

        public void RefreshColliders()
        {
            DeleteColliders_p67();

            containingAtom.GetComponentsInChildren<Rigidbody>().ToList().ForEach(f =>
			{
				try{
                    f.gameObject.AddComponent<TriggerCollide>().OnCollide += ObserveTrigger;
                } catch (Exception e){
					
				}
			});
	
        }

        List<int> GetTriggered(string k)
        {
            List<int> res = new List<int>() { };
            for (var i = 1; i <= totalTabs; i++)
            {
                for (var j = 0; j < bodypartsList.Count; j++)
                {
                    if (k != bodypartsList[j]) continue;
                    if (variableIsTrigger[i][j].val)
                    {
                        res.Add(i);
                    }
                }
            }
            return res;
        }

        void FlashTrigger(string k)
        {
            if (currentToggles[k].backgroundColor == colorGreen) return;
            currentToggles[k].backgroundColor = colorGreen;
            StartCoroutine(CoroutineFlashToggle(k));
        }
        void ObserveTrigger(object sender, TriggerEventArgs e){
			
            Atom parent = null;
			
            foreach (var component in e.collider.gameObject.GetComponentsInParent<Component>())
            {

                var atom = component as Atom;
                if (atom != null)
                {
                    parent = atom;
                    break;
                }
            }
          
		


            var found = "";
            var components = e.collider.transform.parent.GetComponents<Component>();

            var RB = e.collider.attachedRigidbody;

            foreach (var xatom in SuperController.singleton.GetAtoms())
            {
                var RB2 = xatom.rigidbodies.First();
                if (RB == RB2)
                {
                    found = xatom.name;
                    break;
                }

            }

           

            if (e.evtType == EventType.HIT || e.evtType == EventType.ENTERED)
            {
                var actualBodyPart = "";
                if (e.evtType == EventType.ENTERED)
                {
                    var sn = sender.ToString().Replace(" (SPQR.TriggerCollide)", "");
                    actualBodyPart = GetDetectedBodyPart(sn);
                }
                else
                {
                    actualBodyPart = DetectBodyPart_p67(e.collider);
                }
                if (actualBodyPart == "") return;

                //var parentAtom1 = GetObjectAtom_p67(e.collider.gameObject);
                var parentAtom2 = GetObjectAtom_p67(e.collider2.gameObject);
                if (parentAtom2 == containingAtom) return;
                //SuperController.LogMessage(" vs " + e.collider?.name);

                FlashTrigger(actualBodyPart);
                List<int> triggered = GetTriggered(actualBodyPart);
                var magnitude = e.evtType == EventType.ENTERED ? e.collider.bounds.size.magnitude : e.collision.relativeVelocity.magnitude;
                if (e.evtType == EventType.ENTERED)
                {
                    magnitude = 1f;
                    if (e.collider2.attachedRigidbody != null)
                    {
                        magnitude = e.collider2.attachedRigidbody.velocity.magnitude;
                    }
                }
                float level = magnitude / 3.0f;
                if (triggered.Count() == 0) return;
               
                foreach (var triggeredId in triggered)
                {
                    if (myClock[triggeredId] > 0f) continue;

                    //SuperController.LogMessage("collide at high level: " + level + ", threshold: " + collisionThreshold.val);
                    if (level > thresholdMin[triggeredId].val && level < thresholdMax[triggeredId].val)
                    {
                       
                        var xname = found.Length > 0 ? found : parent.name;
                           var xcollider = e.collider.name;
                        if (e.collision != null)
                        {
                            if (e.collision.contacts.Count() > 0)
                            {
                                xcollider = e.collision.contacts[0].otherCollider.attachedRigidbody.name;
                            }
                        }
					   	    //SuperController.LogMessage("collide|"+Time.time +" "+xname+" "+parent.type+" "+xcollider+" "+level);

                            RaeClickTouch(triggeredId, e.collider.name, xname, parent.type, xcollider, level, e.collider, e);
                            //SuperController.LogMessage("!!!!!Receiving event " + parent.name + " of " + found + " of " + e.collider.name);
                            // SuperController.LogMessage("Collide with other object");

                    }
                    else
                    { 
					
				    }
                }
            }
            else{}
			
        }


        //////////////////////////////////////////////
        public string DetectBodyPart_p67(Collider collider)
        {
            GameObject parent1 = null;
            GameObject parent2 = null;
            GameObject parent3 = null;
            GameObject parent4 = null;

            string detected = "";

            string p1 = "", p2 = "", p3 = "", p4 = "";
            if (collider.gameObject.transform.parent != null)
            {
                parent1 = collider.gameObject.transform.parent.gameObject;
                p1 = parent1.name;
            }
            if (parent1.transform.parent != null)
            {
                parent2 = parent1.transform.parent.gameObject;
                p2 = parent2.name;
            }
            if (parent2.transform.parent != null)
            {
                parent3 = parent2.transform.parent.gameObject;
                p3 = parent3.name;
            }
            if (parent3.transform.parent != null)
            {
                parent4 = parent3.transform.parent.gameObject;
                p4 = parent4.name;
            }

            //SuperController.LogMessage("detected: " +  collider.name +"  --- "+ p1 + " : " + p2 + " : " + p3 + " : " + p4);
            if (detected == "") detected = GetDetectedBodyPart(collider.name);
            if (detected == "") detected = GetDetectedBodyPart(p1);
            if (detected == "") detected = GetDetectedBodyPart(p2);
            if (detected == "") detected = GetDetectedBodyPart(p3);
            if (detected == "") detected = GetDetectedBodyPart(p4);
            return detected;

        }
        public Atom GetObjectAtom_p67(GameObject o, int depth = 0)
        {
            if (depth > 20 || o == null) return null;
            Atom parent = o.gameObject.GetComponent<Atom>();
            if (parent == null) return GetObjectAtom_p67(o.transform.parent.gameObject, ++depth);
            return parent;
        }

        public string GetDetectedBodyPart(string p)
        {
            var l = new string[]{
                  "neck","head","hip","chest","abdomen",

                "pelvis",
                "LabiaTrigger","VaginaTrigger","DeepVaginaTrigger","DeeperVaginaTrigger",
                "rThigh","rShin","rFoot", "rToe",
                "lThigh","lShin","lFoot", "lToe",
                "abdomen2",
                "rCollar","rShldr","rForeArm","rHand",
                "lCollar","lShldr","lForeArm","lHand",
                "rPectoral","rNipple","rNippleTrigger",
                "lPectoral","lNipple","lNippleTrigger",

                "LipTrigger","MouthTrigger","lowerJaw",

                "lMid3", "lThumb3", "lIndex3", "lRing3", "lPinky3",
                "rMid3", "rThumb3", "rIndex3", "rRing3", "rPinky3",

            };

            var pLow = p.ToLower();
            if (pLow.Contains("tongue")) return "tongue";
            if (pLow.Contains("chest")) return "chest";
            if (pLow.Contains("nipple")) return "nipple";
            if (pLow.Contains("glute")) return "glutes";

            if (pLow.Contains("lmid") || pLow.Contains("lthumb") || pLow.Contains("lindex") || pLow.Contains("lring") || pLow.Contains("lpinky")) return "hand";
            if (pLow.Contains("rmid") || pLow.Contains("rthumb") || pLow.Contains("rindex") || pLow.Contains("rring") || pLow.Contains("rpinky")) return "hand";

            if (p.EndsWith("Gen1") || p.EndsWith("Gen2") || p.EndsWith("Gen3"))
            {
                return "penis";
            }

            if (p.Contains("AutoColliderpelvisF5") || p.Contains("AutoColliderpelvisFL5") || p.Contains("AutoColliderpelvisFR5") ||
                p.Contains("AutoColliderpelvisF4") || p.Contains("AutoColliderpelvisFL4") || p.Contains("AutoColliderpelvisFR4") ||
                p.Contains("AutoColliderpelvisF6") || p.Contains("AutoColliderpelvisFL6") || p.Contains("AutoColliderpelvisFR6")
                ) return "pelvis";
            if (!l.Contains(p)) return "";
            switch (p)
            {
                case "LabiaTrigger":
                case "VaginaTrigger":
                case "DeepVaginaTrigger":
                case "DeeperVaginaTrigger":
                    return "vagina";
                case "rThigh":
                case "lThigh":
                    return "thigh";
                case "rFoot":
                case "lFoot":
                    return "foot";
                case "rShin":
                case "lShin":
                    return "leg";
                case "chest":
                case "abdomen":
                case "abdomen2":
                    return "upper body";
                case "lNippleTrigger":
                case "rNippleTrigger":
                    return "nipple";
                case "rCollar":
                case "lCollar":
                    return "chest";
                case "rForeArm":
                case "lForeArm":
                    return "arm";
                case "rShldr":
                case "lShldr":
                    return "shoulder";
                case "rHand":
                    return "hand";
                case "lHand":
                    return "hand";
                case "rPectoral":
                case "lPectoral":
                    return "breast";
                case "LipTrigger":
                case "MouthTrigger":
                    return "lips";
                case "lowerJaw":
                    return "jaw";
                case "neck":
                case "head":
                case "hip":
                    return p;

            }

            return "";


        }


        void RaeClickTouch(int triggeredTabId, string sender, string name, string type, string collider, float level, Collider c, TriggerEventArgs triggerEventsArgs = null)
        {
            //SuperController.LogMessage("RaeClickTouch "+ sender +" : "+name+ " :"+type +" "+collider +"  ["+c.name +" !! "+triggerEventsArgs.collider2.name);
			var slevel =  String.Format("{0:0.000}",level);
			sender = sender.Replace(" (SPQR.TriggerCollide)","");
			

          
			//collisionsPreview.val = "PREVIEW: HIT";
			//dtext4.backgroundColor = new Color(0.33f, 1f, 0.33f, 0.7f);
			
            myClock[triggeredTabId] = thresholdCooldown[triggeredTabId].val;
			Trigger(triggeredTabId);
			
		}


        private IEnumerator CoroutineFlashToggle(string k)
        {
            yield return StartCoroutine(Wait(1f));
            currentToggles[k].backgroundColor = colorGrey;
        }

        private IEnumerator CoroutineFlashTrigger(int triggerTabId){
		    yield return StartCoroutine(Wait(1f));
            btnOnCollision.buttonColor = colorGrey;
		 //   collisionsPreview.val = "PREVIEW: -";
			//dtext4.backgroundColor = new Color(1f, 0.33f, 0.33f, 0.7f);
		 }

        private IEnumerator CoroutineFlashExpiredTrigger(int triggerTabId)
        {
            yield return StartCoroutine(Wait(1f));
            btnOnExpire.buttonColor = colorGrey;
            //   collisionsPreview.val = "PREVIEW: -";
            //dtext4.backgroundColor = new Color(1f, 0.33f, 0.33f, 0.7f);
        }


        IEnumerator Wait(float seconds)
		{
		yield return new WaitForSeconds(seconds);
		}

        void UpdateMyString(string name)
        {
        }

		private void CreateTitle(string text, int fontsize, bool right,int spacing){
            CreateTitle(text, fontsize, right);
            Utils.SetupSpacer(this, spacing, right);
        }
        private void CreateTitle(string text, int fontsize, bool right){
                JSONStorableString title1 = new JSONStorableString("title"+(++titles), "\n<size="+fontsize+"><b>"+text+"</b></size>");
                UIDynamicTextField title1text = CreateTextField(title1, right);
                title1text.UItext.supportRichText = true;
                title1text.backgroundColor = new Color(0f, 0f, 0f, 0f);
                title1text.textColor = new Color(0.42f, 0.03f, 0.51f, 1f);
                title1text.height = 100f;
                title1text.UItext.alignment = right ? TextAnchor.MiddleRight : TextAnchor.MiddleLeft;
        }

		
        private void HandleLoadPreset(string path)
        {
           if (path == null) return;
            var jc = (JSONClass)LoadJSON(path);
            base.RestoreFromJSON(jc);

            for (var i = 1; i <= totalTabs; i++)
            {
                myEventTriggerUpdate[i].RestoreFromJSON(jc, base.subScenePrefix, false, true);
                myEventTriggerExpire[i].RestoreFromJSON(jc, base.subScenePrefix, false, true);
            }
            currentTab = 1;
            ChangeTab(1);
        }

        private void HandleSavePreset(string path)
        {
            SuperController.singleton.fileBrowserUI.fileFormat = null;
            if (path == null) return;
            var jc = GetJSON(true,true,true);
            SaveJSON(jc, path);
			SuperController.singleton.DoSaveScreenshot(path);
        }


     
        


    }



}
