﻿using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System;
using UnityEngine;
using UnityEngine.Playables;
using UnityEngine.Animations;
using SimpleJSON;

namespace SPQR
{
	public class BvhBone
	{
		public string name;
		public BvhBone parent;
		public bool hasPosition, hasRotation;
		public int frameOffset;
		public Vector3 offset, posZero = Vector3.zero;
		public bool isHipBone = false;
		public int rotationOrder = RotationOrder.ZXY;

		public string ToDebugString()
		{
			return string.Format("{0} {1} {2} fo:{3} par:{4}", name, hasPosition ? "position" : "", hasRotation ? "rotation" : "", frameOffset, parent != null ? parent.name : "(null)");
		}
	}
}