﻿using System;
using System.Linq;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;

namespace SPQR {
	public class AssetAudioVolume : MVRScript {
		
		bool sceneLoaded = false;

        public Dictionary<string, JSONStorableFloat> sliders = new Dictionary<string, JSONStorableFloat>();
        public override void Init() {
            sliders.Add("volume", new JSONStorableFloat("volume", 1f, CallbackChangeVolume, 0f, 1f, false));
            CreateSlider(sliders["volume"], false);
            RegisterFloat(sliders["volume"]);
        }


		void CallbackChangeVolume(float v)
		{
            var asources = containingAtom.GetComponentsInChildren<AudioSource>();
            foreach (var asource in asources)
            {
				asource.volume = v;
            }
        }


	}
}