﻿using System;
using System.Linq;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;

namespace SPQR
{
    public class ErrorThrower : MVRScript
    {

        bool sceneLoaded = false;
        public override void Init()
        {

            //InvokeRepeating("UpdateSecond", 1f, 1f);
            InvokeRepeating("UpdateSecond5", 1f, 5f);
            //InvokeRepeating("UpdateConstant", 1f, 1f / 30f);
            //InvokeRepeating("UpdateConstant5", 1f, 1f / 5f);
            SuperController.singleton.onSceneLoadedHandlers += OnSceneLoaded;
        }


        void Start()
        {

        }


        void Update()
        {
        }

        void FixedUpdate()
        {

        }
        void UpdateSecond5()
        {
            if (IsDisabled()) return;
            List<string> errorVariations = new List<string> { "error", "eror", "errror", "err", "ErroR", "ERROR", "err0r", "errr", "errar","3rror" };
            string randomError = errorVariations[UnityEngine.Random.Range(0, errorVariations.Count)];
            string[] punctuationVariations = new string[] { "!", "!!", "!?", "?!", "?!!" };
            string randomPunctuation = punctuationVariations[UnityEngine.Random.Range(0, punctuationVariations.Length)];
            string typoError = "";
            for (int i = 0; i < randomError.Length; i++)
            {
                typoError += UnityEngine.Random.value < 0.1f ? (char)UnityEngine.Random.Range(33, 127) : randomError[i];
            }
            SuperController.LogError("ErrorThrower: " + typoError.ToUpper() + randomPunctuation);

        }
        void UpdateConstant()
        {
            if (IsDisabled()) return;

        }
        void UpdateConstant5()
        {
            if (IsDisabled()) return;

        }
        void OnDestroy()
        {
            CancelInvoke();
            SuperController.singleton.onSceneLoadedHandlers -= OnSceneLoaded;
        }

        void OnSceneLoaded()
        {
            sceneLoaded = true;
        }
        bool IsDisabled()
        {
            if (!enabledJSON.val)
            {
                return true;
            }
            return false;
        }
    }
}