﻿using System;
using System.Linq;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;

namespace SPQR {
	public class ErrorsUnderTheRug : MVRScript {
		bool isUiHidden_p67 = false;
		int errorCount_p67 = 0;

		bool sceneLoaded = false;
		public override void Init() {

			//InvokeRepeating("UpdateSecond", 1f, 1f);
			//InvokeRepeating("UpdateConstant", 1f, 1f / 30f);
			//InvokeRepeating("UpdateConstant5", 1f, 1f / 5f);
			SuperController.singleton.onSceneLoadedHandlers += OnSceneLoaded;
		}

	
		void Start() {
		
		}

	
		void Update() {
            if (isUiHidden_p67)
            {
				if(errorCount_p67 != SuperController.singleton.errorCount)
                {
					HideVamUI_p67();
                }
			}

			UpdateCurrentStatus_p67();
		}
		
		void HideVamUI_p67()
        {
			SuperController.singleton.HideMainHUD();

		}
		void UpdateCurrentStatus_p67()
        {
			errorCount_p67 = SuperController.singleton.errorCount;
			isUiHidden_p67 = !SuperController.singleton.MainHUDVisible;
		}


		void FixedUpdate() {
		
		}
		void UpdateSecond()
		{
			if (IsDisabled()) return;

		}
		void UpdateConstant()
		{
			if (IsDisabled()) return;

		}
		void UpdateConstant5()
		{
			if (IsDisabled()) return;

		}
		void OnDestroy()
		{
			CancelInvoke();
			SuperController.singleton.onSceneLoadedHandlers -= OnSceneLoaded;
		}

		void OnSceneLoaded()
		{
			sceneLoaded = true;
		}
		bool IsDisabled()
        {
			if (!enabledJSON.val)
			{
				return true;
			}
			return false;
		}
	}
}