﻿using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;

namespace SPQR {
	public class Gravity : MVRScript {
		
		JSONStorableFloat gravityX;
		JSONStorableFloat gravityY;
		JSONStorableFloat gravityZ;

		public override void Init() {
			gravityX = new JSONStorableFloat("X", 0f, ChangeGravity, -20f, 20f, true);
			RegisterFloat(gravityX);
			CreateSlider(gravityX);
			
			gravityY = new JSONStorableFloat("Y", -9.81f, ChangeGravity, -20f, 20f, true);
			RegisterFloat(gravityY);
			CreateSlider(gravityY);
			
			gravityZ = new JSONStorableFloat("Z", 0f, ChangeGravity, -20f, 20f, true);
			RegisterFloat(gravityZ);
			CreateSlider(gravityZ);
			
			
		}

	
		void Start() {
		
		}

	
		void Update() {
		
		}

	
		void FixedUpdate() {
		
		}
		
		void OnDestroy() {
		}
		
		void ChangeGravity(float n){
		    Physics.gravity = new Vector3(gravityX.val, gravityY.val, gravityZ.val);
		}

	}
}