﻿using System;
using System.Linq;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;

namespace SPQR {
	public class OptimizeSettingLights : Optimize{

        public OptimizeSettingLights(OldVam x) : base(x)
        {
            checkDuration = 3f;
        }

        public override bool CheckChange()
        {
            if (UserPreferences.singleton.pixelLightCount != 1) return true;
            return false;
        }

        public override void DoOptimize()
        {
            UserPreferences.singleton.pixelLightCount = 1;
            Log("Optimized vam setting pixel lights count");
        }


    }
}