﻿using System;
using System.Linq;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;

namespace SPQR {
	public class OptimizeSettingPhysicshq : Optimize{

        public OptimizeSettingPhysicshq(OldVam x) : base(x)
        {
            checkDuration = 2.95f;
        }

        public override bool CheckChange()
        {
            if (UserPreferences.singleton.physicsHighQuality) return true;
            return false;
        }

        public override void DoOptimize()
        {
            UserPreferences.singleton.physicsHighQuality = false;
            Log("Optimized vam setting physics HQ");
        }


    }
}